function is_value_in_list (value, list)
  for i, v in pairs (list) do if (v == value) then return true end end return false
end

--[[
-- the code works, but it makes just a lot of stam in the factorio-current.log

local new_line = string.char(10) -- new line!

function small_serpent (tabl)
  local str = new_line .. '  {' .. new_line
  for i, v in pairs (tabl) do
    local index = (type(i) == "string") and ('["'..i..'"]') or ('['..i..']')
    str = str .. '    ' .. index .. ' = ' .. serpent.line(v) .. ',' .. new_line
  end
  str = str .. '  }'
  return str
end



function add_value_to_list_nd (value, list) -- no doubles
  if not is_value_in_list (value, list) then
    table.insert (list, value)
  end
end


local recipes_for_items = {} -- checking if some items can be made with more than only one way


function add_recipes_amount_for_item (item_name)
  if not recipes_for_items[item_name] then
    recipes_for_items[item_name] = 1
  else
    recipes_for_items[item_name] = recipes_for_items[item_name] + 1
  end
end

local all_items_list = {}

local recipe_prerequisits = {}

local enabled_recipes_list = {}
local disabled_recipes_list = {}

for recipe_name, recipe in pairs (data.raw.recipe) do
  local handlers = recipe.normal and {recipe.normal} or {recipe} -- no expensive
  for i, handler in pairs (handlers) do
  
    local recipe_enabled = (handler.enabled == nil) or handler.enabled
    if recipe_enabled then
      -- code for exception; we don't need to check technologies for enabled recipes
      
    end
    
    
    if handler.result then
      local item_name = handler.result
      add_value_to_list_nd (item_name, all_items_list)
      add_recipes_amount_for_item (item_name)
    elseif handler.results then
      for j, result in pairs (handler.results) do
        local typ = result.type or "item"
        local item_name = result.name or result[1]
        if typ == "item" then
          add_value_to_list_nd (item_name, all_items_list)
          add_recipes_amount_for_item (item_name)
        end
      end
    end
  end
end

local double_recipes_for_items = {}
for item_name, recipe_amounts in pairs (recipes_for_items) do
  if recipe_amounts > 1 then
    table.insert (double_recipes_for_items, item_name)
  end
end

log ('all_items_list [' .. #all_items_list .. ']: ' .. serpent.line (all_items_list))
log ('double_recipes_for_items [' .. #double_recipes_for_items .. ']: ' .. serpent.line (double_recipes_for_items))
log ('recipes_for_items [' .. table_size(recipes_for_items) .. ']: ' .. serpent.block (recipes_for_items))


-- all types
local all_types = {}
for type_name, type_prot in pairs (data.raw) do
  for i, item_name in pairs (all_items_list) do
    if type_prot[item_name] then
      add_value_to_list_nd (type_name, all_types)
    end
  end
end

-- log ('all_types [' .. #all_types .. ']: ' .. serpent.line (all_types))


-- hardcoded item_types: 
local all_item_types = {"ammo", "armor", "gun", "item", "capsule", "repair-tool", "tool", "item-with-entity-data", "item-subgroup", "rail-planner", "module", "night-vision-equipment", "energy-shield-equipment", "battery-equipment", "solar-panel-equipment", "generator-equipment", "active-defense-equipment", "movement-bonus-equipment", "roboport-equipment", "belt-immunity-equipment"}

-- hardcoded entity_types: 
local all_entity_types = {"furnace", "transport-belt", "boiler", "container", "electric-pole", "generator", "offshore-pump", "inserter", "pipe", "radar", "lamp", "pipe-to-ground", "assembling-machine", "wall", "lab", "splitter", "underground-belt", "loader", "car", "roboport", "logistic-container", "construction-robot", "gate", "electric-energy-interface", "mining-drill", "resource", "ammo-turret", "solar-panel", "locomotive", "cargo-wagon", "fluid-wagon", "artillery-wagon", "land-mine", "train-stop", "rail-signal", "rail-chain-signal", "logistic-robot", "rocket-silo", "storage-tank", "pump", "accumulator", "beacon", "arithmetic-combinator", "decider-combinator", "constant-combinator", "power-switch", "programmable-speaker", "reactor", "heat-pipe", "burner-generator", "artillery-turret", "electric-turret", "fluid-turret"}


local recipes_with_techs = {}
local techs_open_recipes = {}

local tech_links = {}

for tech_name, tech in pairs (data.raw.technology) do
  if tech.prerequisites then
    for i, prer_name in pairs (tech.prerequisites) do
      if not tech_links[tech_name] then 
        tech_links[tech_name] = {uses = {prer_name}}
      else
        if not tech_links[tech_name].uses then tech_links[tech_name].uses = {} end
        table.insert (tech_links[tech_name].uses, prer_name)
      end
      
      if not tech_links[prer_name] then 
        tech_links[prer_name] = {used_in = {tech_name}}
      else
        if not tech_links[prer_name].used_in then tech_links[prer_name].used_in = {} end
        table.insert (tech_links[prer_name].used_in, tech_name)
      end
    end
  end

  if tech.effects then
    for i, effect in pairs (tech.effects) do
      if effect.type == "unlock-recipe" then
        local recipe_name = effect.recipe
        if not recipes_with_techs[recipe_name] then 
          recipes_with_techs[recipe_name] = {tech_name}
        else
          table.insert (recipes_with_techs[recipe_name], tech_name)
        end
        if not techs_open_recipes[tech_name] then 
          techs_open_recipes[tech_name] = {recipe_name}
        else
          table.insert (techs_open_recipes[tech_name], recipe_name)
        end
      end
    end
  end
end

-- small_serpent (tabl)
-- log ('recipes_with_techs [' .. table_size(recipes_with_techs) .. ']: ' .. small_serpent (recipes_with_techs))
-- log ('techs_open_recipes [' .. table_size(techs_open_recipes) .. ']: ' .. small_serpent (techs_open_recipes))

-- log ('tech_links [' .. table_size(tech_links) .. ']: ' .. small_serpent (tech_links))


function deep_tech_links (tech_link)
  local tech_structure = {}
  if tech_link.used_in then
    for i, tech_name in pairs (tech_link.used_in) do
      local next_tech_link = tech_links[tech_name]
      local deep_structure = deep_tech_links (next_tech_link)
      if deep_structure then 
        tech_structure[tech_name] = deep_structure
      else
        table.insert (tech_structure, tech_name)
      end
    end
  else
    -- tech_structure = nil
  end
  return tech_structure
end

local tech_tree = {}

for tech_name, tech_link in pairs (tech_links) do
  if not tech_link.uses then -- first tech
    tech_tree[tech_name] = deep_tech_links (tech_link)
  end
end

-- log ('tech_tree [' .. table_size(tech_tree) .. ']: ' .. serpent.block (tech_tree))

]]
--------------------------------------------------------------------------------------------------

local all_item_types = {"ammo", "armor", "gun", "item", "capsule", "repair-tool", "tool", "item-with-entity-data", "item-subgroup", "rail-planner", "module", "night-vision-equipment", "energy-shield-equipment", "battery-equipment", "solar-panel-equipment", "generator-equipment", "active-defense-equipment", "movement-bonus-equipment", "roboport-equipment", "belt-immunity-equipment"}

function get_item_fluid_prototype (name)
  if data.raw.fluid[name] then
    return data.raw.fluid[name]
  else
    for i, item_type in pairs (all_item_types) do
      local prototype = data.raw[item_type][name]
      if prototype then return prototype end
    end
  end
end


local resources = {}

for resource_name, resource in pairs (data.raw.resource) do
  local results = resource.minable.results or {{name = resource.minable.result}}
  for i, result in pairs (results) do
    local name = result.name or result[1]
    if name then
      local prototype = get_item_fluid_prototype (name)
      if prototype then
        prototype.dif = 1
      else
        log ('no prototype by ' .. name)
      end
    else
      log ('no result.name by ' .. resource_name .. ' ' .. i)
    end
  end
end


--------------------------------------------------------------------------------------------------



--------------------------------------------------------------------------------------------------
-- predefined values
local ingredient_by_recipes = {}
local result_by_recipes = {}

for recipe_name, recipe in pairs (data.raw.recipe) do
  local handler = recipe.normal or recipe
  for i, ingredient in pairs (handler.ingredients) do
    local ingredient_name = ingredient[1] or ingredient.name
    if not (ingredient_by_recipes[ingredient_name]) then
      ingredient_by_recipes[ingredient_name] = {recipe_name}
    else
      table.insert (ingredient_by_recipes[ingredient_name], recipe_name)
    end
  end
  if handler.result then
    if not (result_by_recipes[handler.result]) then
      result_by_recipes[handler.result] = {recipe_name}
    else
      table.insert (result_by_recipes[handler.result], recipe_name)
    end
  elseif handler.results then
    for i, result in pairs (handler.results) do
      local result_name = result[1] or result.name
      if not (result_by_recipes[result_name]) then
        result_by_recipes[result_name] = {recipe_name}
      else
        table.insert (result_by_recipes[result_name], recipe_name)
      end
    end
  end
end

log ('ingredient_by_recipes: ' .. table_size (ingredient_by_recipes))
log ('result_by_recipes: ' .. table_size (result_by_recipes))

local effect_by_technologies = {}

for tech_name, tech in pairs (data.raw.technology) do
  local effects = tech.effects
  if effects then
    for i, effect in pairs (effects) do
      if effect.type == "unlock-recipe" then
        local recipe_name = effect.recipe
        if recipe_name then
          if not effect_by_technologies[recipe_name] then
            effect_by_technologies[recipe_name] = {tech_name}
          else
            table.insert (effect_by_technologies[recipe_name], tech_name)
          end
        else
          log ('technology prototype: ["'..tech_name .. '"] has wrong effect: ' .. serpent.line (effect))
        end
      end
    end
  end
end
log ('effect_by_technologies: ' .. table_size (effect_by_technologies))

--------------------------------------------------------------------------------------------------



function technologies_for_recipe (recipe_name)
  return effect_by_technologies[recipe_name] 
end


-- function recipes_for_ingredient (ingredient_name)
  -- return ingredient_by_recipes[ingredient_name]
-- end

function recipes_with_result (result_name)
  return result_by_recipes[result_name]
end


function main_prerequisites_for_recipe (recipe_name, tech_name)
  -- log ('4')
  local recipe = data.raw.recipe[recipe_name]
  if recipe then
    local prerequisites = {}
    local handler = recipe.normal and recipe.normal or recipe
    local ingredients = handler.ingredients
    if ingredients then
      for i, ingredient in pairs (ingredients) do
        local ingredient_name = ingredient[1] or ingredient.name -- item or fluid
        local type = ingredient.type or 'item' -- item or fluid
        -- local recipes = recipes_for_ingredient (ingredient_name) -- list of recipe names
        local recipes = recipes_with_result (ingredient_name) -- list of recipe names
        
        if recipes and (#recipes == 1) then
          log ('technology ["' .. tech_name .. '"] ingredient_name: ["' .. ingredient_name .. '"] by recipe: ["' .. recipes[1] .. '"]')
          
          for j, recipe_name in pairs (recipes) do
            local technologies = technologies_for_recipe (recipe_name)
            if technologies then
            -- if technologies and (#technologies == 1) then
              for k, prerequisite_tech_name in pairs (technologies) do
                if not is_value_in_list (prerequisite_tech_name, prerequisites) and not (tech_name == prerequisite_tech_name) then
                  table.insert (prerequisites, prerequisite_tech_name)
                  log ('main_prerequisites_for_recipe: tech: ["'.. tech_name ..'"] prerequisite_tech: ["' .. prerequisite_tech_name .. '"] while recipe: ["' .. recipe_name .. '"]')
                end
              end
            end
          end
        end
      end
    end
  return prerequisites
  else
    log('wrong recipe name, no recipe with the name ["'..recipe_name..'"]')
  end
end


function main_prerequisites (tech)
  local tech_name = tech.name
  
  if tech.effects then
    -- log ('3.1')
    local prerequisites = {}
    for i, effect in pairs (tech.effects) do
      -- log ('3.2')
      if effect.type == "unlock-recipe" then
        -- log ('3.3')
        local recipe_name = effect.recipe
        local new_prerequisites = main_prerequisites_for_recipe (recipe_name, tech_name) -- returns list of technology names
        if new_prerequisites then
          -- log ('3.4')
          for j, prerequisite in pairs (new_prerequisites) do
            -- log ('3.5')
            if not is_value_in_list (prerequisite, prerequisites) then
              if not (tech_name == prerequisite) then
                table.insert(prerequisites, prerequisite)
              end
            end
          end
        end
      end
    end
  return prerequisites
  end
end


function main_tech (tech)
  -- log ('2')
  local prerequisites = main_prerequisites (tech) -- returns table with strings; list of technology names
  
  if prerequisites then
    if not (tech.prerequisites) then tech.prerequisites = {} end
    for i, prerequisite in pairs (prerequisites) do
      if not is_value_in_list (prerequisite, tech.prerequisites) then
        table.insert (tech.prerequisites, prerequisite)
        log ('added prerequisite: ["'..prerequisite..'"] to technology: ["' ..tech.name..'"]')
      end
    end
  end
  
end

for tech_name, tech in pairs (data.raw.technology) do
  -- log ('1')
  tech.prerequisites = {}
  main_tech (tech)
end





































