-- data.raw.technology["steel-processing"].prerequisites



-- code from my mod: _NoCyclesInTechTree_0.0.1

function is_value_in_list (value, list)
  for i, v in pairs (list) do
    if value == v then
      return true
    end
  end
  return false
end



function get_list_where_used (tech_name)
  local list = {}
    for tech_name_1, tech in pairs (data.raw.technology) do
      local added = false
      if tech.prerequisites then
        for i, value in pairs (tech.prerequisites) do
          if value == tech_name and not added then
            table.insert(list, tech_name_1)
            added = true
          end
        end
      end
    end
  log ('Tech: '..tech_name..' is defined by '..serpent.line(list))
  return list
end

local where_used = {}

for tech_name, tech in pairs (data.raw.technology) do
  if not where_used[tech_name] then where_used[tech_name] = {} end -- at least empty table for all technologies
  
  if tech.prerequisites then
    for i, prerequisite_name in pairs (tech.prerequisites) do
      if not where_used[prerequisite_name] then where_used[prerequisite_name] = {} end
      if not is_value_in_list (tech_name, where_used[prerequisite_name]) then
        table.insert(where_used[prerequisite_name], tech_name)
      end
    end
  end
end



function remove_tech_name_from_prerequisites (tech_name, tech)
  if tech.prerequisites then
    for i, prer in pairs (tech.prerequisites) do
      if prer == tech_name then
        log ('prerequisit ["' .. prer .. '"] was removed from tech ["' .. tech.name .. '"]')
        tech.prerequisites[i] = nil
      end
    end
  end
end


function remove_prer_from_tech (prer_name, tech_name, n)
  local tech = data.raw.technology[tech_name]
  if tech.prerequisites then
    for i, prer in pairs (tech.prerequisites) do
      if prer == prer_name then
        log ('prerequisit ["' .. prer .. '"] was removed from tech ["' .. tech_name .. '"] >' .. n)
        tech.prerequisites[i] = nil
      end
    end
  end
end


function clean_list (list)
  -- remove first element from the list till repeat from {3,5,2,7,8,2} to {2,7,8,2}
  local name = list[#list] -- the last one]
  for i = 1, #list do
    if not (name == list[1]) then
      table.remove(list, 1)
    else
      return
    end
  end
end


function get_smart_tech_prer (list)
  local easiest_tech -- the easiest one must have no prerequisite
  
end


function deep_prerequisites (tech_name, list, deep)
  local list = table.deepcopy(list) or {}
  local tech = data.raw.technology[tech_name]
  local has_cycle = false
  deep = deep+1
  
  if is_value_in_list (tech_name, list) then
    table.insert (list, tech_name)
    clean_list (list)
    log ('['..deep..'] Tech: ["'..tech_name..'"] cycle detected! '..serpent.line(list) ..'; prerequisites are disabled')
    
    for i = 1, (#list - 1) do
      local tech_name_2 = list[i]
      local prer_name_2 = list[i+1]
      -- remove_prer_from_tech (tech_name_2, prer_name_2, 1)
      remove_prer_from_tech (prer_name_2, tech_name_2, 2)
    end
    --[[
    for i, v_tech_name in pairs (list) do
      -- for j, w_tech_name in pairs (get_list_where_used (v_tech_name)) do
      for j, w_tech_name in pairs (where_used[v_tech_name]) do
        -- data.raw.technology[w_tech_name].prerequisites = nil
        remove_tech_name_from_prerequisites (tech_name, data.raw.technology[w_tech_name])
      end
    end
      
    -- for j, w_tech_name in pairs (get_list_where_used (tech_name)) do
    for j, w_tech_name in pairs (where_used[tech_name]) do
      -- data.raw.technology[w_tech_name].prerequisites = nil
      remove_tech_name_from_prerequisites (tech_name, data.raw.technology[w_tech_name])
    end
    tech.prerequisites = nil
    ]]
    return true
  end
  
  table.insert (list, tech_name)
  
  if tech.prerequisites then
    -- log ('['..deep..'] Tech: '..tech_name..' and prerequisites: '..serpent.line(tech.prerequisites))
    for i, value in pairs (tech.prerequisites) do
      if deep_prerequisites (value, list, deep) then 
        return true 
      end
    end
  end
  return has_cycle
end



-- local science_packs = {}

for tech_name, tech in pairs (data.raw.technology) do
  if deep_prerequisites (tech_name, nil, 0) then
    log (tech_name .. ' not ok') 
  end
  
  -- if tech.unit and tech.unit.ingredients then
    -- for i, ing in pairs (tech.unit.ingredients) do
      -- local sp_name = ing[1]
      -- if not is_value_in_list (sp_name, science_packs) then
        -- table.insert (science_packs, sp_name)
      -- end
    -- end
  -- end
  
end

--[[

local techs_for_science_pack = {}

for tech_name, tech in pairs (data.raw.technology) do
  -- data.raw.technology["diamond-mining"].effects[28] = {type = "unlock-recipe", recipe = "production-science-pack"}
  if tech.effects then
    for j, effect in pairs (tech.effects) do
      if effect.type == "unlock-recipe" then
        local recipe_name = effect.recipe -- not good, recipe name can be not same as science pack name
        if is_value_in_list (recipe_name, science_packs) then
          if not techs_for_science_pack[recipe_name] then techs_for_science_pack[recipe_name] = {} end
          table.insert (techs_for_science_pack[recipe_name], tech_name)
        end
      end
    end
  end
end

]]


for tech_name, tech in pairs (data.raw.technology) do
  if not (tech.prerequisites) or (#tech.prerequisites == 0) and not (tech.enabled) then
    tech.enabled = true
  end
end












